// BrowsDlg.cpp : implementation file
//
//
// SyncURLs version 1.0
// Copyright 1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#include "stdafx.h"
#include "SyncURLs.h"
#include "StatDlg.h"
#include "SUDoc.h"
#include "BrowsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBrowsDlg dialog


CBrowsDlg::CBrowsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBrowsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBrowsDlg)
	//}}AFX_DATA_INIT
}


void CBrowsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBrowsDlg)
	DDX_Control(pDX, IDC_cmbSelectUser, m_cmbSelectUser);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBrowsDlg, CDialog)
	//{{AFX_MSG_MAP(CBrowsDlg)
	ON_CBN_SELCHANGE(IDC_cmbSelectUser, OnSelchangecmbSelectUser)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBrowsDlg message handlers

void CBrowsDlg::OnOK() 
{
	CString strUserName, strFileName;
	int nSel;

	nSel = m_cmbSelectUser.GetCurSel();
	m_cmbSelectUser.GetLBText(nSel, strUserName);
	Retrieve_Path(strUserName, strFileName);
	if (strFileName.Right(1) != '\\')
		strFileName += '\\';
	strFileName += "BOOKMARK.HTM";
	m_pMyDoc->m_strNSCUserName = strUserName;
	m_pMyDoc->m_strNSCPath = strFileName;
	CDialog::OnOK();
}

void CBrowsDlg::OnSelchangecmbSelectUser() 
{
}

BOOL CBrowsDlg::OnInitDialog() 
{
	int nCount;

	CDialog::OnInitDialog();
	Get_User_Names();
	nCount = m_cmbSelectUser.GetCount();
	switch (nCount)
	{
	case 0:
		AfxMessageBox("SyncURLs has located settings for one or more Netscape 4.x user profiles.\n"
			"However, either the directories specified in your Registry do not exist\n"
			"or you do not have permission to access the files they contain.", MB_ICONINFORMATION);
		m_pMyDoc->m_bNSCPresent = FALSE;
		EndDialog(IDOK);
		break;
	case 1:
		if (m_nUserCount > 1)
			AfxMessageBox("SyncURLs has located settings for multiple Netscape 4.x\n"
			"user profiles, but only one user profile can be accessed.", MB_ICONINFORMATION);
		OnOK();
	}
	return TRUE;
}


void CBrowsDlg::Get_User_Names()
{
	HKEY hKey;
	HRESULT hResult;
	char szBuff[_MAX_PATH];
	DWORD len, key_index = 0;
	CString strFileName;

	hResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, sz_CommunicatorKey, KEY_ENUMERATE_SUB_KEYS, 0, &hKey);
	if (hResult != ERROR_SUCCESS)
		return;
	len = sizeof(szBuff);
	m_nUserCount = 0;
	do
	{
		hResult = RegEnumKeyEx(hKey, key_index, szBuff, &len, 0, NULL, NULL, NULL);
		if (hResult != ERROR_SUCCESS)
			break;
		if (Retrieve_Path(szBuff, strFileName))
		{
			++m_nUserCount;
			if (strFileName.Right(1) != '\\')
				strFileName += '\\';
			strFileName += "BOOKMARK.HTM";
			if (Check_Access(strFileName))
				m_cmbSelectUser.AddString(szBuff);
		}
		++key_index;
		len = sizeof(szBuff);
	} while (hResult != ERROR_NO_MORE_ITEMS);
	RegCloseKey(hKey);
	m_cmbSelectUser.SetCurSel(0);
}

// Retrieves the path for the specified Netscape Communicator user profile.
BOOL CBrowsDlg::Retrieve_Path(LPCTSTR szDataName, CString & strFileName)
{
	HKEY hKey;
	HRESULT hResult;
	unsigned char szBuff1[_MAX_PATH];
	char szBuff2[_MAX_PATH];
	DWORD dwLen, dwType;
	CString strKeyName;

	strKeyName.Format("%s\\%s", sz_CommunicatorKey, szDataName);

	hResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, strKeyName, KEY_QUERY_VALUE, 0, &hKey);
	if (hResult != ERROR_SUCCESS)
		return FALSE;
	dwLen = sizeof(szBuff1);
	dwType = 0;
	hResult = RegQueryValueEx(hKey, "DirRoot", 0, &dwType, szBuff1, &dwLen);
	RegCloseKey(hKey);
	if (hResult != ERROR_SUCCESS)
		return FALSE;
	switch(dwType)
	{
	case REG_SZ:
		strFileName = szBuff1;
		return TRUE;
	case REG_EXPAND_SZ:
		if (ExpandEnvironmentStrings((const char *)szBuff1, szBuff2, sizeof(szBuff2)) != 0)
		{
			strFileName = szBuff2;
			return TRUE;
		}
	default:
		return FALSE;
	}
}

// Ensures that the specified file exists and, if it does,
// that the user can both read from it and write to it.
BOOL CBrowsDlg::Check_Access(LPCTSTR szFileName)
{
	CFile file;

	if (file.Open(szFileName, CFile::modeRead, NULL))
	{
		file.Close();
		if (file.Open(szFileName, CFile::modeReadWrite, NULL))
		{
			file.Close();
			return TRUE;
		}
	}
	return FALSE;
}
