// MyList.cpp : implementation file
//
//
// SyncURLs version 1.0
// Copyright 1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#include "stdafx.h"
#include "SyncURLs.h"
#include "MyList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyList

CMyList::CMyList()
{
}

CMyList::~CMyList()
{
}


BEGIN_MESSAGE_MAP(CMyList, CListCtrl)
	//{{AFX_MSG_MAP(CMyList)
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_NOTIFY_REFLECT(LVN_KEYDOWN, OnKeydown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyList message handlers

void CMyList::OnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPoint point;
	UINT flags;
	int iItem;

	GetCursorPos(&point);
	ScreenToClient(&point);
	iItem = HitTest(point, &flags);
	if (iItem >= 0)
		if ((flags & LVHT_ONITEMSTATEICON) != 0)
			Toggle_Item(iItem);
	*pResult = 0;
}

// Called when:
//   User clicks an item's checkbox
//   User double-clicks an item's path or icon.
//   User presses spacebar when an item is selected. 
void CMyList::Toggle_Item(int iItem)
{
	LV_ITEM lvi;

	lvi.mask = LVIF_PARAM | LVIF_STATE;		// Set flags to retrieve item info.
	lvi.stateMask = LVIS_STATEIMAGEMASK;
	lvi.iItem = iItem;
	lvi.iSubItem = 0;
	GetItem(&lvi);							// Get the info.
	if (lvi.lParam <0)						// If item is a header,
		return;								// nothing to do.
	if (lvi.state == 0x2000)	// Toggle checkbox state.
		lvi.state = 0x3000;
	else
		lvi.state = 0x2000;
	lvi.mask = LVIF_STATE;		// Set flag.
	SetItem(&lvi);				// Set new state.
	Update(iItem);				// Force control to redraw the item.
}

// Called when user double-clicks an item.
void CMyList::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPoint point;
	int iItem;

	GetCursorPos(&point);		// Get mouse position.
	ScreenToClient(&point);		// Convert to client coordinates.
	iItem = HitTest(point);		// Get item (if any) the user clicked on.
	if (iItem >= 0)				// If user did click on an item,
		Toggle_Item(iItem);		// toggle its checkbox.
	*pResult = 0;
}

// Called when user presses a key.
void CMyList::OnKeydown(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDown = (LV_KEYDOWN*)pNMHDR;

	if (pLVKeyDown->wVKey == VK_SPACE)			// Was it spacebar?
	{
		int nCount = GetItemCount();			// Get # of items.
		for (int i = 0; i < nCount; i++)		// Walk the list.
		{
			if (GetItemState(i, LVIS_SELECTED) != 0)	// If item is selected,
			{
				Toggle_Item(i);							// Toggle its state.
				break;
			}
		}
	}
	*pResult = 0;
}
