// SyncURLs.h : main header file for the SYNCURLS application
//
//
// SyncURLs version 1.0
// Copyright 1998 Ziff-Davis Inc.
// First published in PC Magazine, US Edition
// January 6, 1998
// Written by Gregory A. Wolking
//

#if !defined(AFX_SYNCURLS_H__A03AD406_1CC5_11D1_84C6_444553540000__INCLUDED_)
#define AFX_SYNCURLS_H__A03AD406_1CC5_11D1_84C6_444553540000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

// Structure for bookmark array.
struct DOC_ELEMENT
{
	UINT path_offset;		// Offset into path array for parent folder.
	CString* page;			// Pointer to bookmark name.
	CString* url;			// Pointer to URL string.
	CString* comment;		// Pointer to comment string (NULL = no comment present)
	LONG add_date;			// Date added (Netscape only)
	LONG mod_date;			// Modified date (Netscape only)
	LONG visit_date;		// Last visit date (Netscape only)
};

// Structure for path list array.
struct PATH_ELEMENT
{
	CString* path;		// Pointer to path name.
	BOOL processed;		// Flag used by recursive routines.
	UINT parent;		// Array offset to its parent directory.
	BOOL locked;		// Indicates folder exists on disk.
	UINT selected;		// Selection state for export:
						// 1 = not selected
						// 2 = fully selceted (i.e., all subfolders are selected)
						// 3 = partially selected (i.e., some subfolders are not selected)
};

// Structure used when checking document for duplicate
// bookmark names.
struct DUP_ELEMENT
{
	CString* name;		// Bookmark name.
	UINT offset;		// Offset into the document array.
};

// Structure used for weeding duplicate URLs
struct DUP_URL_ELEMENT
{
	CString* url;
	UINT offset;
	BOOL remove;
};

// Structure used for weeding duplicate URLs
struct DUP_URL_SET
{
	UINT start;
	UINT end;
};

/////////////////////////////////////////////////////////////////////////////
// CSyncURLsApp:
// See SyncURLs.cpp for the implementation of this class
//

class CSyncURLsApp : public CWinApp
{
public:
	CSyncURLsApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSyncURLsApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CSyncURLsApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYNCURLS_H__A03AD406_1CC5_11D1_84C6_444553540000__INCLUDED_)
